VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIShellItemImageFactory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 09/2018

Option Explicit

Private Const ERR_BASE As Long = 40670
Private Const CLSID_ShellItemImageFactory As String = ""
Private Const IID_IShellItemImageFactory As String = "{BCC18B79-BA16-442F-80C4-8A59C30C463B}"

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_GetImage
End Enum

Dim m_initialized As Boolean
Dim m_Interface As Interface_Data

Friend Function GetImage(ByRef tSIZE As SIZE, ByVal Flags As SIIGBF) As Long
    
    Dim lRet As Long
    Dim hBm As Long
    Dim phBm As Long
    
    phBm = VarPtr(hBm)
    
    If x_OleInvoke(vtb_GetImage, tSIZE.cx, tSIZE.cy, Flags, phBm) Then
    
        lRet = hBm

    End If
    
    GetImage = lRet

End Function

Public Sub RaiseError(Optional ByVal Raise As Boolean = True)

    m_Interface.RaiseErrors = Raise

End Sub

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True
    m_Interface.ifc = pInterface
    m_initialized = True

End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface

End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As Boolean

    Dim ret As Long

    If Not m_initialized Then

        InterfaceError m_Interface, ecd_OleInvoke

    Else

        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)

    End If

End Function

Private Sub x_RaiseError()

    With m_Interface

        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsIShellItemImageFactory", .etx

        .ecd = 0
        .etx = ""

    End With

End Sub

